<?php
/*
Plugin Name: OCD Plugin Stats
Plugin URI: http://www.makerblock.com
Description: An easy way to monitor your plugin download statistics
Version: 0.1
Date: 02-29-2012
Author: MakerBlock
Author URI: http://www.makerblock.com
**************************************************************
	Copyright 2012  MakerBlock  

    This program is free software; you can redistribute it and/or modify
    it under the terms of the GNU General Public License, version 2, as 
    published by the Free Software Foundation.

    This program is distributed in the hope that it will be useful,
    but WITHOUT ANY WARRANTY; without even the implied warranty of
    MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
    GNU General Public License for more details.

    You should have received a copy of the GNU General Public License
    along with this program; if not, write to the Free Software
    Foundation, Inc., 51 Franklin St, Fifth Floor, Boston, MA  02110-1301  USA
*/
//	Create Defaults, Upon Activation
	register_activation_hook( __FILE__, array('mbk_ocd_plugin_stats', 'install') );
//	Upon Deactivation, Uninstall Everything
	register_deactivation_hook( __FILE__, array('mbk_ocd_plugin_stats', 'uninstall') );
//	Hook into the `wp_dashboard_setup` to register the widget
	add_action('wp_dashboard_setup', array('mbk_ocd_plugin_stats', 'widget_action_hook'));
//	Plugin, as a class
	class mbk_ocd_plugin_stats
		{
		//	Create Defaults, Upon Activation
			static function uninstall() 
				{  }
		//	Create Defaults, Upon Activation
			static function install() 
				{  }
		//	Create Dashboard Widget
				//	Dashboard Widget API - http://codex.wordpress.org/Dashboard_Widgets_API 
				//	An In-Depth Look at the Dashboard Widgets API - http://theme.it/an-in-depth-look-at-the-dashboard-widgets-api/
			static function widget_content()
				{ 
				$plugins = get_option('dashboard_widget_options');
					$plugins = explode(",", $plugins['mbk_ocd_plugin_stats_widget']['items']);
				$content = "<style> table#mbk_ocd_plugin_table {  } table#mbk_ocd_plugin_table tr td { border:1px solid black; padding:3px; text-align:center; } </style><table id='mbk_ocd_plugin_table'><tr><th>Plugin</th><th>Today</th><th>Yesterday</th><th>Last Week</th><th>All Time</th></tr>";
				for ($i=0;$i<count($plugins);$i++)
					{
					$url = 'http://wordpress.org/extend/plugins/'. trim($plugins[$i]) .'/stats/';
					$src = file_get_contents($url);
					$dom = new DOMDocument();
						$dom->preserveWhiteSpace = false; 
						$dom->formatOutput = true; 
						$dom->loadHTML($src);
					$title 		= $dom->getElementsByTagName('h2') ->item(1) ->nodeValue;
					$today 		= $dom->getElementsByTagName('td') ->item(0) ->nodeValue;
					$yesterday	= $dom->getElementsByTagName('td') ->item(1) ->nodeValue;
					$lastweek	= $dom->getElementsByTagName('td') ->item(2) ->nodeValue;
					$alltime	= $dom->getElementsByTagName('td') ->item(3) ->nodeValue;
					$content .= "<tr><td><a href='$url'>$title</a></td><td>$today</td><td>$yesterday</td><td>$lastweek</td><td>$alltime</td></tr>";
					}
				$content .= "</table>";
				echo $content;
				}
		//	Create configuration link for dashboard
			static function mbk_ocd_plugin_stats_configuration()
				{
				$widget_id = 'mbk_ocd_plugin_stats_widget'; 		// This must be the same ID we set in wp_add_dashboard_widget
				$form_id = 'mbk_ocd_plugin_stats_widget_control'; 	// Set this to whatever you want
				// Checks whether there are already dashboard widget options in the database
					if ( !$widget_options = get_option( 'dashboard_widget_options' ) )
						{ $widget_options = array(); } 				// If not, we create a new array 
				// Check whether we have information for this form
					if ( !isset($widget_options[$widget_id]) )
						{ $widget_options[$widget_id] = array(); } // If not, we create a new array
				// Check whether our form was just submitted
					if ( 'POST' == $_SERVER['REQUEST_METHOD'] && isset($_POST[$form_id]) ) 
						{
						$plugins = $_POST[$form_id]['items'];							// Get the value. In this case ['items'] is from the input field with the name of '.$form_id.'[items]
						$widget_options[$widget_id]['items'] = $plugins; 				// Set the plugins of items
						update_option( 'dashboard_widget_options', $widget_options );	// Update our dashboard widget options so we can access later
						}
				// Check if we have set the plugins of posts previously. If we didn't, then we just set it as empty. This value is used when we create the input field
					$plugins = isset( $widget_options[$widget_id]['items'] ) ? $widget_options[$widget_id]['items'] : '';
				// Create our form fields. Pay very close attention to the name part of the input field.
					echo '<p><label for="mbk_ocd_plugin_stats_names">' . __('Plugin slugs, separated by ",":') . '</label>';
					echo "<input id='mbk_ocd_plugin_stats_names' name='".$form_id."[items]' type='text' value='$plugins'/ size='53'></p>";
				}
		//	Create function to use in the action hook
			static function widget_action_hook()
				{ wp_add_dashboard_widget('mbk_ocd_plugin_stats_widget', 'OCD Plugin Stats', array('mbk_ocd_plugin_stats', 'widget_content'), array('mbk_ocd_plugin_stats', 'mbk_ocd_plugin_stats_configuration')); }
		}
?>